<?php
class ContentsController extends AdminAppController {
    public $helpers = array('Html', 'Form','Session','Paginator');
    public $components = array('Session','Paginator','search-master.Prg');
    public $presetVars = true;
    var $paginate = array('limit'=>20,'maxLimit'=>500,'page'=>1,'order'=>array('Content.link_name'=>'asc'));
    public function index()
    {
        
    }    
    public function pages()
    {
        $this->Prg->commonProcess();
        $this->Paginator->settings = $this->paginate;
        $this->Paginator->settings['conditions'] = $this->Content->parseCriteria($this->Prg->parsedParams());
        $this->set('Content', $this->Paginator->paginate());        
    }
    public function add()
    {
        if ($this->request->is('post'))
        {
            $this->Content->create();
            try
            {
                if ($this->Content->save($this->request->data))
                {
                    $this->Session->setFlash(__('Your Page has been saved.'),'flash',array('alert'=>'success'));
                    return $this->redirect(array('action' => 'pages'));
                }
            }
            catch (Exception $e)
            {
                $this->Session->setFlash(__('Page Url already exist.'),'flash',array('alert'=>'danger'));
                return $this->redirect(array('action' => 'pages'));
            }
        }
    }
    public function edit($id = null)
    {
        if (!$id)
        {
            throw new NotFoundException(__('Invalid post'));
        }
        $ids=explode(",",$id);
        $post=array();
        foreach($ids as $id)
        {
            $post[]=$this->Content->findByid($id);
        }
        $this->set('Content',$post);
        if (!$post)
        {
            throw new NotFoundException(__('Invalid post'));
        }
        if ($this->request->is(array('post', 'put')))
        {
            $this->Content->id = $id;
            try
            {
                foreach($this->data['Content'] as $key => $value)
                {
                    if ($this->Content->save($this->request->data['Content'][$key]))
                    {
                        $this->Session->setFlash(__('Your pages has been updated.'),'flash',array('alert'=>'success'));                        
                    }
                }
                return $this->redirect(array('action' => 'pages'));
            }
            catch (Exception $e)
            {
                $this->Session->setFlash(__('Page Url already exist.'),'flash',array('alert'=>'danger'));
                return $this->redirect(array('action' => 'pages'));
            }
        }
        if (!$this->request->data)
        {
            $this->request->data = $post;
        }
    }    
    public function deleteall()
    {
        if ($this->request->is('post'))
        {
            foreach($this->data['Content']['id'] as $key => $value)
            {
                $this->Content->delete($value);
            }
            $this->Session->setFlash(__('Your page has been deleted.'),'flash',array('alert'=>'success'));
        }        
        $this->redirect(array('action' => 'pages'));
    }
    public function published($id=null,$mode=null)
    {
        if (!$id || !$mode)
        {
            $this->Session->setFlash(__('Invalid Post.'),'flash',array('alert'=>'danger'));
            $this->redirect(array('action' => 'pages'));
        }
        $post = $this->Content->findById($id);
        if (!$post)
        {
            $this->Session->setFlash(__('Invalid Post.'),'flash',array('alert'=>'danger'));
            $this->redirect(array('action' => 'pages'));
        }
        $this->Content->id = $id;
        try
        {
            $published="";
            if($mode=="Yes")
            $published="Unpublished";
            else
            $published="Published";
            $userArr=array('id'=>$id,'published'=>$published);
            if ($this->Content->save($userArr))
            {
                $this->Session->setFlash(__("Your page has been %s .",$published),'flash',array('alert'=>'success'));
                return $this->redirect(array('action' => 'pages'));
            }
            else
            {
                $this->Session->setFlash(__('Something wrong.'),'flash',array('alert'=>'danger'));
                return $this->redirect(array('action' => 'pages'));            
            }
        }
        catch (Exception $e)
        {
            $this->Session->setFlash(__('Something wrong.'),'flash',array('alert'=>'danger'));
            return $this->redirect(array('action' => 'pages'));            
        }
    }
}
